{% block nav %}{% endblock %}
{% block css %}
    <style>
        select.form-control, #showAllButton {
            display: inline;
            width: 200px;
            margin-left: 30px;
        }
    </style>
{% endblock %}

<div id="filters">
    <div id="showAllButton">
        <a href="{{ path('app_order_all', {'showAll':'showAll'}) }}">
            <div class="btn btn-primary">Show all orders</div>
        </a>
    </div>

    <select class="form-control" id="countryFilter">
        <option disabled selected value="">Filter by country</option>
        <option value="">Show all</option>
        {% for country in countryList %}
            <option value="{{ country.idCountry }}">{{ country.name }}</option>
        {% endfor %}
    </select>
</div>

<table id="orderTable" class="table table-sm table-striped table-responsive">
    <thead>
    <tr>
        <th>Id</th>
        <th>Date</th>
        <th>Customer</th>
        <th>Delivery address</th>
        <th>Country</th>
        <th>Products</th>
        <th>Status</th>
    </tr>
    </thead>
    <tbody>
    {% for order in orders %}
        <tr data-id="{{ order.id }}">
            <td data-bs-toggle="modal" data-bs-target="#orderDetailsModal">{{ order.id }}</td>
            <td data-bs-toggle="modal" data-bs-target="#orderDetailsModal">{{ order.date }}</td>
            <td data-bs-toggle="modal" data-bs-target="#orderDetailsModal">{{ order.customerName }}</td>
            <td data-bs-toggle="modal" data-bs-target="#orderDetailsModal">{{ order.address }}</td>
            <td data-bs-toggle="modal" data-bs-target="#orderDetailsModal">{{ order.country.name }}</td>
            <td data-bs-toggle="modal" data-bs-target="#orderDetailsModal">
                {% if order.products is empty %}
                    No products found
                {% else %}
                    <ul>
                        {% for product in order.products %}
                            <li>{{ product.quantity }}x {{ product.name }}</li>
                        {% endfor %}
                    </ul>
                {% endif %}
            </td>
            <td><select class="form-select" id="selectStatus" data-order="{{ order.id }}">
                    {% for status in statusList %}
                        <option label="{{ status.name }}"
                                value="{{ status.idOrderState }}" {% if order.status.id == status.idOrderState %} selected {% endif %}></option>
                    {% endfor %}
                </select>
            </td>
        </tr>
    {% endfor %}
    </tbody>
    <tfoot></tfoot>
</table>

<script>
    $(function () {
        $("#orderTable").dataTable({
            "bJQueryUI": true,
            "bSort": false,
            "bPaginate": true,
            "sPaginationType": "full_numbers",
            "iDisplayLength": 5,
            "lengthMenu": [5, 10, 25, 50, 75, 100],
            "ordering": true,
            "order": [[1, 'desc']],
            "searching": true
        });

        $('#selectStatus').on('change', function () {
            let orderId = $(this).data('order');
            let statusId = $(this).val();

            $.post("{{ path('app_order_change_status') }}",{'orderId': orderId, 'status': statusId});
        })

        let table = $('#orderTable').DataTable();
        initializeFilters(table);

        table.draw();
    });

    function initializeFilters(table) {
        $("#orderTable_filter.dataTables_filter").append($("#countryFilter"));
        $("#orderTable_filter.dataTables_filter").append($("#showAllButton"));

        let countryIndex = 0;
        $("#orderTable th").each(function (i) {
            if ($($(this)).html() == "Country") {
                countryIndex = i;
                return false;
            }
        });

        $.fn.dataTable.ext.search.push(
            function (settings, data) {
                let selectedItem = $('#countryFilter').find('option:selected').html();
                let country = data[countryIndex];
                if (selectedItem === "Show all" || selectedItem === "Filter by country" || country.includes(selectedItem)) {
                    return true;
                }
                return false;
            }
        );

        $("#countryFilter").on('change', function () {
            table.draw();
        });
    }
</script>
